/**
This file is part of a project licensed under the GNU General Public License v3.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
*/

import deepEqual from "fast-deep-equal";
import { fetchPageContent, fetchPageContentXML } from "@/utils/api.js";
const json = require("../../assets/page1.json");
const xml =
  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><PcGts xmlns="http://schema.primaresearch.org/PAGE/gts/pagecontent/2013-07-15" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://schema.primaresearch.org/PAGE/gts/pagecontent/2013-07-15 http://schema.primaresearch.org/PAGE/gts/pagecontent/2013-07-15/pagecontent.xsd">    <Metadata>        <Creator>Transkribus Processing API</Creator>        <Created>2022-09-16T11:33:20.628+02:00</Created>        <LastChange>2022-09-16T11:33:30.707+02:00</LastChange>    </Metadata>    <Page imageFilename="orig_proc-api-a8731fcb-c81e-445d-8cc8-4fc852a1b79e.jpg" imageWidth="1500" imageHeight="2212">        <ReadingOrder>            <OrderedGroup id="ro_1663320826176" caption="Regions reading order">                <RegionRefIndexed index="0" regionRef="r1"/>                <RegionRefIndexed index="1" regionRef="r2"/>            </OrderedGroup>        </ReadingOrder>        <TextRegion orientation="0.0" id="r1" custom="readingOrder {index:0}">            <Coords points="59,437 59,2153 1453,2153 1453,437"/>            <TextLine id="r1l1" custom="readingOrder {index:0}">                <Coords points="352,493 361,493 372,504 378,499 398,500 422,521 452,533 456,434 435,437 416,424 409,428 399,420 384,425 355,417"/>                <Baseline points="361,490 389,493 417,495 445,492"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l2" custom="readingOrder {index:1}">                <Coords points="982,517 1046,509 1066,527 1090,516 1102,527 1173,530 1209,520 1227,529 1240,418 1221,425 1182,415 1159,431 1104,372 1070,366 1024,382 999,374"/>                <Baseline points="995,488 1020,486 1045,485 1070,485 1095,487 1120,491 1145,495 1170,500 1195,507 1221,514"/>                <Word id="r1l2_w1" custom="readingOrder {index:0}">                    <Unicode>6</Unicode>                    <TextEquiv>                        <Unicode>6</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>6</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l3" custom="readingOrder {index:2}">                <Coords points="735,589 749,586 755,582 760,572 768,569 732,472 723,478 717,476 710,483 704,481 696,484"/>                <Baseline points="740,578 759,571"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l4" custom="readingOrder {index:3}">                <Coords points="693,716 702,716 752,689 775,693 787,683 801,685 802,616 794,616 782,606 777,609 765,605 746,594 715,609 696,607"/>                <Baseline points="703,674 732,673 762,675 792,675"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l5" custom="readingOrder {index:4}">                <Coords points="871,748 881,745 890,748 897,738 923,734 905,576 851,577"/>                <Baseline points="875,712 911,708"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l6" custom="readingOrder {index:5}">                <Coords points="65,788 79,785 97,800 100,799 106,804 116,803 110,714 101,715 90,726 83,725 80,721 71,729 61,730"/>                <Baseline points="74,782 106,780"/>                <Word id="r1l6_w1" custom="readingOrder {index:0}">                    <Unicode>1</Unicode>                    <TextEquiv>                        <Unicode>1</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>1</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l7" custom="readingOrder {index:6}">                <Coords points="670,964 1050,934 1346,949 1364,875 1244,801 1156,801 1064,852 963,799 914,831 765,797 671,834"/>                <Baseline points="679,931 712,929 746,928 780,927 814,926 848,925 881,925 915,924 949,924 983,925 1017,925 1050,925 1084,926 1118,927 1152,928 1185,929 1219,930 1253,931 1287,932 1321,934 1355,935"/>                <Word id="r1l7_w1" custom="readingOrder {index:0}">                    <Unicode>Tutti Frutti</Unicode>                    <TextEquiv>                        <Unicode>Alli</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l7_w2" custom="readingOrder {index:1}">                    <Coords points="956,887 956,947 1314,947 1314,887"/>                    <TextEquiv>                        <Unicode>Frulli</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>Alli Frulli</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l8" custom="readingOrder {index:7}">                <Coords points="59,1099 76,1096 83,1101 93,1092 100,1097 121,1098 117,1005 103,1004 71,1035 56,1035"/>                <Baseline points="67,1067 111,1065"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l9" custom="readingOrder {index:8}">                <Coords points="661,1124 793,1075 904,1106 1030,1082 1149,1111 1241,1081 1395,1107 1442,1097 1444,1008 1026,1036 966,1002 746,993 663,1032"/>                <Baseline points="671,1067 709,1067 747,1067 785,1067 823,1067 861,1068 899,1068 937,1069 975,1069 1013,1070 1052,1071 1090,1071 1128,1072 1166,1073 1204,1074 1242,1075 1280,1076 1318,1077 1356,1078 1394,1080 1433,1082"/>                <Word id="r1l9_w1" custom="readingOrder {index:0}">                    <Unicode>EGekookle ef geconsijle vrucht en doet men</Unicode>                    <TextEquiv>                        <Unicode>EGekookle</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w2" custom="readingOrder {index:1}">                    <Coords points="916,1028 916,1088 943,1088 943,1028"/>                    <TextEquiv>                        <Unicode>ef</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w3" custom="readingOrder {index:2}">                    <Coords points="964,1030 964,1090 1118,1090 1118,1030"/>                    <TextEquiv>                        <Unicode>geconsijle</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w4" custom="readingOrder {index:3}">                    <Coords points="1139,1033 1139,1093 1230,1093 1230,1033"/>                    <TextEquiv>                        <Unicode>vrucht</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w5" custom="readingOrder {index:4}">                    <Coords points="1237,1035 1237,1095 1264,1095 1264,1035"/>                    <TextEquiv>                        <Unicode>en</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w6" custom="readingOrder {index:5}">                    <Coords points="1293,1037 1293,1097 1362,1097 1362,1037"/>                    <TextEquiv>                        <Unicode>doet</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l9_w7" custom="readingOrder {index:6}">                    <Coords points="1377,1040 1377,1100 1432,1100 1432,1040"/>                    <TextEquiv>                        <Unicode>men</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>EGekookle ef geconsijle vrucht en doet men</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l10" custom="readingOrder {index:9}">                <Coords points="613,1168 627,1168 641,1175 644,1171 661,1171 661,1054 653,1054 639,1044 632,1051 613,1054"/>                <Baseline points="622,1164 652,1164"/>                <TextEquiv>                    <Unicode> </Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l11" custom="readingOrder {index:10}">                <Coords points="656,1196 1280,1220 1389,1175 1456,1187 1437,1127 657,1125"/>                <Baseline points="665,1164 704,1164 743,1164 782,1165 821,1165 860,1165 899,1165 939,1165 978,1166 1017,1166 1056,1166 1095,1167 1134,1167 1173,1167 1213,1168 1252,1168 1291,1169 1330,1169 1369,1170 1408,1170 1448,1171"/>                <Word id="r1l11_w1" custom="readingOrder {index:0}">                    <Unicode>een scholel, hodal zeeersl goed kous zijn gewwr¬</Unicode>                    <TextEquiv>                        <Unicode>een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w2" custom="readingOrder {index:1}">                    <Coords points="733,1125 733,1185 847,1185 847,1125"/>                    <TextEquiv>                        <Unicode>scholel,</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w3" custom="readingOrder {index:2}">                    <Coords points="864,1125 864,1185 957,1185 957,1125"/>                    <TextEquiv>                        <Unicode>hodal</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w4" custom="readingOrder {index:3}">                    <Coords points="973,1126 973,1186 1077,1186 1077,1126"/>                    <TextEquiv>                        <Unicode>zeeersl</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w5" custom="readingOrder {index:4}">                    <Coords points="1088,1127 1088,1187 1159,1187 1159,1127"/>                    <TextEquiv>                        <Unicode>goed</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w6" custom="readingOrder {index:5}">                    <Coords points="1181,1128 1181,1188 1258,1188 1258,1128"/>                    <TextEquiv>                        <Unicode>kous</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w7" custom="readingOrder {index:6}">                    <Coords points="1279,1129 1279,1189 1334,1189 1334,1129"/>                    <TextEquiv>                        <Unicode>zijn</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l11_w8" custom="readingOrder {index:7}">                    <Coords points="1361,1130 1361,1190 1459,1190 1459,1130"/>                    <TextEquiv>                        <Unicode>gewwr¬</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>een scholel, hodal zeeersl goed kous zijn gewwr¬</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l12" custom="readingOrder {index:11}">                <Coords points="585,1306 635,1314 715,1268 858,1293 1400,1282 1400,1229 1247,1206 1063,1235 872,1208 779,1237 586,1175"/>                <Baseline points="594,1260 633,1261 673,1261 713,1261 753,1261 793,1262 833,1262 873,1262 913,1262 953,1263 993,1263 1032,1263 1072,1263 1112,1263 1152,1263 1192,1263 1232,1263 1272,1263 1312,1263 1352,1262 1392,1262"/>                <Word id="r1l12_w1" custom="readingOrder {index:0}">                    <Unicode>Een daarna belagt men zo mel billerkoeljes el</Unicode>                    <TextEquiv>                        <Unicode>Een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w2" custom="readingOrder {index:1}">                    <Coords points="712,1221 712,1281 809,1281 809,1221"/>                    <TextEquiv>                        <Unicode>daarna</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w3" custom="readingOrder {index:2}">                    <Coords points="825,1222 825,1282 931,1282 931,1222"/>                    <TextEquiv>                        <Unicode>belagt</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w4" custom="readingOrder {index:3}">                    <Coords points="947,1223 947,1283 1003,1283 1003,1223"/>                    <TextEquiv>                        <Unicode>men</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w5" custom="readingOrder {index:4}">                    <Coords points="1028,1223 1028,1283 1052,1283 1052,1223"/>                    <TextEquiv>                        <Unicode>zo</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w6" custom="readingOrder {index:5}">                    <Coords points="1076,1223 1076,1283 1133,1283 1133,1223"/>                    <TextEquiv>                        <Unicode>mel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w7" custom="readingOrder {index:6}">                    <Coords points="1149,1223 1149,1283 1353,1283 1353,1223"/>                    <TextEquiv>                        <Unicode>billerkoeljes</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l12_w8" custom="readingOrder {index:7}">                    <Coords points="1369,1222 1369,1282 1401,1282 1401,1222"/>                    <TextEquiv>                        <Unicode>el</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>Een daarna belagt men zo mel billerkoeljes el</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l13" custom="readingOrder {index:12}">                <Coords points="66,1365 119,1356 159,1376 206,1356 226,1371 286,1362 355,1386 388,1363 426,1367 428,1269 392,1270 333,1313 267,1306 238,1323 180,1300 160,1317 120,1318 68,1294"/>                <Baseline points="74,1351 100,1350 126,1350 153,1351 179,1351 205,1352 232,1353 258,1354 285,1355 311,1356 337,1357 364,1357 390,1357 417,1357"/>                <Word id="r1l13_w1" custom="readingOrder {index:0}">                    <Unicode>biseris de Bargge</Unicode>                    <TextEquiv>                        <Unicode>biseris</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l13_w2" custom="readingOrder {index:1}">                    <Coords points="214,1312 214,1372 247,1372 247,1312"/>                    <TextEquiv>                        <Unicode>de</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l13_w3" custom="readingOrder {index:2}">                    <Coords points="267,1316 267,1376 394,1376 394,1316"/>                    <TextEquiv>                        <Unicode>Bargge</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>biseris de Bargge</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l14" custom="readingOrder {index:13}">                <Coords points="650,1364 877,1368 917,1395 1341,1370 1461,1394 1462,1336 1408,1323 651,1312"/>                <Baseline points="659,1356 698,1357 738,1357 778,1358 817,1359 857,1359 897,1360 936,1361 976,1361 1016,1362 1056,1362 1095,1363 1135,1363 1175,1364 1214,1364 1254,1364 1294,1365 1333,1365 1373,1365 1413,1365 1453,1366"/>                <Word id="r1l14_w1" custom="readingOrder {index:0}">                    <Unicode>Boel dan in een pan 1½ lopel sijne wille suiker,</Unicode>                    <TextEquiv>                        <Unicode>Boel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w2" custom="readingOrder {index:1}">                    <Coords points="778,1318 778,1378 832,1378 832,1318"/>                    <TextEquiv>                        <Unicode>dan</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w3" custom="readingOrder {index:2}">                    <Coords points="858,1319 858,1379 879,1379 879,1319"/>                    <TextEquiv>                        <Unicode>in</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w4" custom="readingOrder {index:3}">                    <Coords points="901,1320 901,1380 948,1380 948,1320"/>                    <TextEquiv>                        <Unicode>een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w5" custom="readingOrder {index:4}">                    <Coords points="970,1321 970,1381 1024,1381 1024,1321"/>                    <TextEquiv>                        <Unicode>pan</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w6" custom="readingOrder {index:5}">                    <Coords points="1050,1322 1050,1382 1076,1382 1076,1322"/>                    <TextEquiv>                        <Unicode>1½</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w7" custom="readingOrder {index:6}">                    <Coords points="1098,1323 1098,1383 1178,1383 1178,1323"/>                    <TextEquiv>                        <Unicode>lopel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w8" custom="readingOrder {index:7}">                    <Coords points="1199,1324 1199,1384 1263,1384 1263,1324"/>                    <TextEquiv>                        <Unicode>sijne</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w9" custom="readingOrder {index:8}">                    <Coords points="1285,1325 1285,1385 1359,1385 1359,1325"/>                    <TextEquiv>                        <Unicode>wille</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l14_w10" custom="readingOrder {index:9}">                    <Coords points="1375,1325 1375,1385 1466,1385 1466,1325"/>                    <TextEquiv>                        <Unicode>suiker,</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>Boel dan in een pan 1½ lopel sijne wille suiker,</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l15" custom="readingOrder {index:14}">                <Coords points="65,1474 225,1484 298,1459 401,1487 443,1474 466,1497 561,1516 562,1429 525,1420 411,1418 389,1402 328,1427 232,1403 130,1425 66,1414"/>                <Baseline points="75,1452 100,1452 125,1452 150,1452 175,1453 201,1453 226,1454 251,1454 276,1455 301,1455 327,1456 352,1456 377,1457 402,1457 427,1458 453,1458 478,1458 503,1459 528,1459 554,1459"/>                <Word id="r1l15_w1" custom="readingOrder {index:0}">                    <Unicode>een lepel bloem een halt pijpje</Unicode>                    <TextEquiv>                        <Unicode>een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l15_w2" custom="readingOrder {index:1}">                    <Coords points="139,1413 139,1473 216,1473 216,1413"/>                    <TextEquiv>                        <Unicode>lepel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l15_w3" custom="readingOrder {index:2}">                    <Coords points="231,1414 231,1474 301,1474 301,1414"/>                    <TextEquiv>                        <Unicode>bloem</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l15_w4" custom="readingOrder {index:3}">                    <Coords points="339,1416 339,1476 385,1476 385,1416"/>                    <TextEquiv>                        <Unicode>een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l15_w5" custom="readingOrder {index:4}">                    <Coords points="401,1418 401,1478 463,1478 463,1418"/>                    <TextEquiv>                        <Unicode>halt</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l15_w6" custom="readingOrder {index:5}">                    <Coords points="471,1419 471,1479 563,1479 563,1419"/>                    <TextEquiv>                        <Unicode>pijpje</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>een lepel bloem een halt pijpje</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l16" custom="readingOrder {index:15}">                <Coords points="590,1482 684,1498 781,1468 991,1502 1179,1470 1354,1500 1423,1486 1424,1436 1035,1411 841,1434 756,1397 643,1429 590,1397"/>                <Baseline points="598,1457 638,1458 679,1458 720,1459 761,1459 802,1460 842,1460 883,1460 924,1461 965,1461 1006,1461 1046,1462 1087,1462 1128,1462 1169,1463 1210,1463 1250,1463 1291,1464 1332,1464 1373,1465 1414,1465"/>                <Word id="r1l16_w1" custom="readingOrder {index:0}">                    <Unicode>vannille ende Doyers van drie cieren; roer</Unicode>                    <TextEquiv>                        <Unicode>vannille</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w2" custom="readingOrder {index:1}">                    <Coords points="842,1420 842,1480 915,1480 915,1420"/>                    <TextEquiv>                        <Unicode>ende</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w3" custom="readingOrder {index:2}">                    <Coords points="933,1421 933,1481 1031,1481 1031,1421"/>                    <TextEquiv>                        <Unicode>Doyers</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w4" custom="readingOrder {index:3}">                    <Coords points="1049,1422 1049,1482 1098,1482 1098,1422"/>                    <TextEquiv>                        <Unicode>van</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w5" custom="readingOrder {index:4}">                    <Coords points="1129,1422 1129,1482 1177,1482 1177,1422"/>                    <TextEquiv>                        <Unicode>drie</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w6" custom="readingOrder {index:5}">                    <Coords points="1208,1423 1208,1483 1342,1483 1342,1423"/>                    <TextEquiv>                        <Unicode>cieren;</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l16_w7" custom="readingOrder {index:6}">                    <Coords points="1354,1425 1354,1485 1415,1485 1415,1425"/>                    <TextEquiv>                        <Unicode>roer</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>vannille ende Doyers van drie cieren; roer</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l17" custom="readingOrder {index:16}">                <Coords points="53,1589 1447,1605 1448,1534 1285,1513 218,1530 55,1489"/>                <Baseline points="62,1545 130,1548 199,1550 268,1552 337,1554 406,1555 475,1557 543,1558 612,1559 681,1560 750,1561 819,1561 888,1562 957,1563 1025,1564 1094,1564 1163,1565 1232,1566 1301,1567 1370,1568 1439,1570"/>                <Word id="r1l17_w1" custom="readingOrder {index:0}">                    <Unicode>dit alles goed booreen; menghe Thel aan mel drie hierglazen koude melk of room</Unicode>                    <TextEquiv>                        <Unicode>dit</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w2" custom="readingOrder {index:1}">                    <Coords points="125,1508 125,1568 193,1568 193,1508"/>                    <TextEquiv>                        <Unicode>alles</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w3" custom="readingOrder {index:2}">                    <Coords points="224,1511 224,1571 286,1571 286,1511"/>                    <TextEquiv>                        <Unicode>goed</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w4" custom="readingOrder {index:3}">                    <Coords points="322,1514 322,1574 467,1574 467,1514"/>                    <TextEquiv>                        <Unicode>booreen;</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w5" custom="readingOrder {index:4}">                    <Coords points="478,1517 478,1577 581,1577 581,1517"/>                    <TextEquiv>                        <Unicode>menghe</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w6" custom="readingOrder {index:5}">                    <Coords points="628,1519 628,1579 701,1579 701,1519"/>                    <TextEquiv>                        <Unicode>Thel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w7" custom="readingOrder {index:6}">                    <Coords points="716,1520 716,1580 757,1580 757,1520"/>                    <TextEquiv>                        <Unicode>aan</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w8" custom="readingOrder {index:7}">                    <Coords points="783,1521 783,1581 835,1581 835,1521"/>                    <TextEquiv>                        <Unicode>mel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w9" custom="readingOrder {index:8}">                    <Coords points="861,1522 861,1582 918,1582 918,1522"/>                    <TextEquiv>                        <Unicode>drie</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w10" custom="readingOrder {index:9}">                    <Coords points="944,1523 944,1583 1105,1583 1105,1523"/>                    <TextEquiv>                        <Unicode>hierglazen</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w11" custom="readingOrder {index:10}">                    <Coords points="1136,1525 1136,1585 1229,1585 1229,1525"/>                    <TextEquiv>                        <Unicode>koude</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w12" custom="readingOrder {index:11}">                    <Coords points="1245,1526 1245,1586 1307,1586 1307,1526"/>                    <TextEquiv>                        <Unicode>melk</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w13" custom="readingOrder {index:12}">                    <Coords points="1327,1527 1327,1587 1354,1587 1354,1527"/>                    <TextEquiv>                        <Unicode>of</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l17_w14" custom="readingOrder {index:13}">                    <Coords points="1374,1528 1374,1588 1431,1588 1431,1528"/>                    <TextEquiv>                        <Unicode>room</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>dit alles goed booreen; menghe Thel aan mel drie hierglazen koude melk of room</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l18" custom="readingOrder {index:17}">                <Coords points="49,1666 1395,1672 1380,1617 50,1602"/>                <Baseline points="59,1652 125,1654 191,1655 258,1656 324,1657 390,1658 457,1659 523,1660 589,1661 656,1661 722,1662 788,1662 855,1662 921,1663 987,1663 1054,1664 1120,1664 1186,1665 1253,1665 1319,1666 1386,1667"/>                <Word id="r1l18_w1" custom="readingOrder {index:0}">                    <Unicode>zel hel op het vuur, voer hel goet volsal hel korkl en giet hel warm op de</Unicode>                    <TextEquiv>                        <Unicode>zel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w2" custom="readingOrder {index:1}">                    <Coords points="118,1614 118,1674 165,1674 165,1614"/>                    <TextEquiv>                        <Unicode>hel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w3" custom="readingOrder {index:2}">                    <Coords points="191,1615 191,1675 213,1675 213,1615"/>                    <TextEquiv>                        <Unicode>op</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w4" custom="readingOrder {index:3}">                    <Coords points="240,1616 240,1676 287,1676 287,1616"/>                    <TextEquiv>                        <Unicode>het</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w5" custom="readingOrder {index:4}">                    <Coords points="303,1617 303,1677 393,1677 393,1617"/>                    <TextEquiv>                        <Unicode>vuur,</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w6" custom="readingOrder {index:5}">                    <Coords points="409,1618 409,1678 467,1678 467,1618"/>                    <TextEquiv>                        <Unicode>voer</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w7" custom="readingOrder {index:6}">                    <Coords points="493,1619 493,1679 546,1679 546,1619"/>                    <TextEquiv>                        <Unicode>hel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w8" custom="readingOrder {index:7}">                    <Coords points="568,1621 568,1681 636,1681 636,1621"/>                    <TextEquiv>                        <Unicode>goet</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w9" custom="readingOrder {index:8}">                    <Coords points="668,1621 668,1681 774,1681 774,1621"/>                    <TextEquiv>                        <Unicode>volsal</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w10" custom="readingOrder {index:9}">                    <Coords points="801,1622 801,1682 848,1682 848,1622"/>                    <TextEquiv>                        <Unicode>hel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w11" custom="readingOrder {index:10}">                    <Coords points="874,1622 874,1682 965,1682 965,1622"/>                    <TextEquiv>                        <Unicode>korkl</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w12" custom="readingOrder {index:11}">                    <Coords points="996,1623 996,1683 1018,1683 1018,1623"/>                    <TextEquiv>                        <Unicode>en</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w13" custom="readingOrder {index:12}">                    <Coords points="1044,1624 1044,1684 1103,1684 1103,1624"/>                    <TextEquiv>                        <Unicode>giet</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w14" custom="readingOrder {index:13}">                    <Coords points="1124,1624 1124,1684 1166,1684 1166,1624"/>                    <TextEquiv>                        <Unicode>hel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w15" custom="readingOrder {index:14}">                    <Coords points="1187,1625 1187,1685 1267,1685 1267,1625"/>                    <TextEquiv>                        <Unicode>warm</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w16" custom="readingOrder {index:15}">                    <Coords points="1304,1625 1304,1685 1325,1685 1325,1625"/>                    <TextEquiv>                        <Unicode>op</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l18_w17" custom="readingOrder {index:16}">                    <Coords points="1351,1626 1351,1686 1377,1686 1377,1626"/>                    <TextEquiv>                        <Unicode>de</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>zel hel op het vuur, voer hel goet volsal hel korkl en giet hel warm op de</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l19" custom="readingOrder {index:18}">                <Coords points="55,1766 768,1812 1383,1773 1284,1711 55,1704"/>                <Baseline points="64,1755 129,1757 195,1758 260,1759 326,1760 391,1761 457,1762 522,1762 588,1763 653,1763 719,1763 784,1764 850,1764 915,1764 981,1764 1046,1765 1112,1765 1177,1765 1243,1765 1308,1766 1374,1766"/>                <Word id="r1l19_w1" custom="readingOrder {index:0}">                    <Unicode>billerkoekjes waarmete de vruchten belegd zijn. Een lepel Rhun er door</Unicode>                    <TextEquiv>                        <Unicode>billerkoekjes</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w2" custom="readingOrder {index:1}">                    <Coords points="283,1720 283,1780 471,1780 471,1720"/>                    <TextEquiv>                        <Unicode>waarmete</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w3" custom="readingOrder {index:2}">                    <Coords points="505,1722 505,1782 539,1782 539,1722"/>                    <TextEquiv>                        <Unicode>de</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w4" custom="readingOrder {index:3}">                    <Coords points="568,1723 568,1783 693,1783 693,1723"/>                    <TextEquiv>                        <Unicode>vruchten</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w5" custom="readingOrder {index:4}">                    <Coords points="715,1723 715,1783 812,1783 812,1723"/>                    <TextEquiv>                        <Unicode>belegd</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w6" custom="readingOrder {index:5}">                    <Coords points="840,1724 840,1784 920,1784 920,1724"/>                    <TextEquiv>                        <Unicode>zijn.</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w7" custom="readingOrder {index:6}">                    <Coords points="931,1724 931,1784 989,1784 989,1724"/>                    <TextEquiv>                        <Unicode>Een</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w8" custom="readingOrder {index:7}">                    <Coords points="1011,1725 1011,1785 1097,1785 1097,1725"/>                    <TextEquiv>                        <Unicode>lepel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w9" custom="readingOrder {index:8}">                    <Coords points="1119,1725 1119,1785 1205,1785 1205,1725"/>                    <TextEquiv>                        <Unicode>Rhun</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w10" custom="readingOrder {index:9}">                    <Coords points="1244,1725 1244,1785 1278,1785 1278,1725"/>                    <TextEquiv>                        <Unicode>er</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l19_w11" custom="readingOrder {index:10}">                    <Coords points="1301,1726 1301,1786 1364,1786 1364,1726"/>                    <TextEquiv>                        <Unicode>door</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>billerkoekjes waarmete de vruchten belegd zijn. Een lepel Rhun er door</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l20" custom="readingOrder {index:19}">                <Coords points="59,1887 264,1866 629,1907 738,1882 991,1920 971,1813 819,1834 733,1796 590,1831 459,1800 311,1837 60,1807"/>                <Baseline points="68,1859 113,1860 159,1860 205,1861 251,1861 296,1862 342,1863 388,1863 434,1864 479,1864 525,1864 571,1865 617,1865 662,1865 708,1866 754,1866 800,1866 845,1866 891,1866 937,1866 983,1866"/>                <Word id="r1l20_w1" custom="readingOrder {index:0}">                    <Unicode>verhoogt den smank. Hel wordt kand gegeten.</Unicode>                    <TextEquiv>                        <Unicode>verhoogt</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w2" custom="readingOrder {index:1}">                    <Coords points="234,1821 234,1881 288,1881 288,1821"/>                    <TextEquiv>                        <Unicode>den</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w3" custom="readingOrder {index:2}">                    <Coords points="309,1823 309,1883 448,1883 448,1823"/>                    <TextEquiv>                        <Unicode>smank.</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w4" custom="readingOrder {index:3}">                    <Coords points="479,1824 479,1884 544,1884 544,1824"/>                    <TextEquiv>                        <Unicode>Hel</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w5" custom="readingOrder {index:4}">                    <Coords points="559,1825 559,1885 666,1885 666,1825"/>                    <TextEquiv>                        <Unicode>wordt</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w6" custom="readingOrder {index:5}">                    <Coords points="692,1826 692,1886 772,1886 772,1826"/>                    <TextEquiv>                        <Unicode>kand</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l20_w7" custom="readingOrder {index:6}">                    <Coords points="799,1826 799,1886 953,1886 953,1826"/>                    <TextEquiv>                        <Unicode>gegeten.</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>verhoogt den smank. Hel wordt kand gegeten.</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l21" custom="readingOrder {index:20}">                <Coords points="919,2097 989,2076 1122,2090 1161,2071 1218,2093 1365,2070 1427,2110 1454,2103 1454,2020 1359,2001 1259,2019 1227,1995 1153,2030 1092,1994 1029,2020 918,2009"/>                <Baseline points="927,2072 952,2071 978,2070 1004,2069 1030,2069 1056,2068 1082,2068 1108,2068 1134,2068 1160,2068 1186,2068 1211,2068 1237,2068 1263,2068 1289,2069 1315,2068 1341,2068 1367,2068 1393,2068 1419,2067 1445,2066"/>                <Word id="r1l21_w1" custom="readingOrder {index:0}">                    <Unicode>Arnaldine Swaving</Unicode>                    <TextEquiv>                        <Unicode>Arnaldine</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l21_w2" custom="readingOrder {index:1}">                    <Coords points="1207,2028 1207,2088 1437,2088 1437,2028"/>                    <TextEquiv>                        <Unicode>Swaving</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>Arnaldine Swaving</Unicode>                </TextEquiv>            </TextLine>            <TextLine id="r1l22" custom="readingOrder {index:21}">                <Coords points="1146,2165 1175,2165 1205,2142 1222,2149 1274,2137 1294,2156 1317,2152 1325,2159 1353,2149 1353,2087 1330,2090 1298,2078 1241,2108 1222,2096 1184,2101 1168,2089 1146,2092"/>                <Baseline points="1155,2134 1182,2136 1209,2137 1236,2137 1263,2135 1290,2135 1317,2135 1344,2137"/>                <Word id="r1l22_w1" custom="readingOrder {index:0}">                    <Unicode>Pr. H.</Unicode>                    <TextEquiv>                        <Unicode>Pr.</Unicode>                    </TextEquiv>                </Word>                <Word id="r1l22_w2" custom="readingOrder {index:1}">                    <Coords points="1288,2095 1288,2155 1355,2155 1355,2095"/>                    <TextEquiv>                        <Unicode>H.</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>Pr. H.</Unicode>                </TextEquiv>            </TextLine>            <TextEquiv>                <Unicode/>            </TextEquiv>        </TextRegion>        <TextRegion orientation="0.0" id="r2" custom="readingOrder {index:1}">            <Coords points="1364,0 1364,129 1420,129 1420,0"/>            <TextLine id="r2l1" custom="readingOrder {index:0}">                <Coords points="1356,86 1375,91 1385,84 1406,98 1428,98 1428,28 1414,31 1400,26 1381,40 1356,43"/>                <Baseline points="1364,78 1392,79 1420,78"/>                <Word id="r2l1_w1" custom="readingOrder {index:0}">                    <Unicode>2</Unicode>                    <TextEquiv>                        <Unicode>2</Unicode>                    </TextEquiv>                </Word>                <TextEquiv>                    <Unicode>2</Unicode>                </TextEquiv>            </TextLine>            <TextEquiv>                <Unicode/>            </TextEquiv>        </TextRegion>    </Page></PcGts>';

import { parsePageContent, parseXML } from "@/utils/xml.js";

export const state = () => ({
  id: null,
  data: null,
  selected: null,
  centerLineID: null,
  selectedTag: null,
  highlighted: null,
  isError: false,
  isReady: false,
  isLoading: false,
  xmlModel: null,
  wasSaved: false,
  wasEdited: false,
  editLayoutHorizontal: true,
  iiifUrl:
    "https://files.transkribus.eu/iiif/2/XITIHIQXRRBAHPZDHDPHWHMP/info.json",
  xmlJson: parsePageContent(xml),
  // iiifUrl: "",
  // xmlJson: null,
  xml: xml,
});

export const mutations = {
  update(state, params) {
    for (const key in params)
      if (!deepEqual(state[key], params[key])) state[key] = params[key];
  },
};

export const actions = {
  update({ commit }, params) {
    commit("update", params);
  },
  reset({ dispatch }) {
    dispatch("update", {
      id: null,
      data: null,
      selected: null,
      centerLineID: null,
      selectedTag: null,
      highlighted: null,
      isError: false,
      isready: false,
      isLoading: false,
      xmlModel: parseXML(xml),
      wasSaved: false,
      wasEdited: false,
      editLayoutHorizontal: true,
      // iiifUrl:
      //   "https://files.transkribus.eu/iiif/2/XITIHIQXRRBAHPZDHDPHWHMP/info.json",
      // xmlJson: parsePageContent(xml),
      iiifUrl: "",
      xmlJson: null,
      xml: xml,
    });
  },
  select({ dispatch, state }, { origin, target }) {
    dispatch("update", { selected: { origin, target } });
  },
  highlight({ dispatch, state }, { origin, target }) {
    dispatch("update", { highlighted: { origin, target } });
  },
  centerLine({ dispatch, state }, { origin, target }) {
    dispatch('update', { centerLineID: { origin, target } })
  },
  setSelectedTag({ dispatch, state }, { selectedTag }) {
    dispatch("update", { selectedTag: selectedTag });
  },
  setIIIF({ dispatch, state }, { iiifUrl }) {
    dispatch("update", { iiifUrl: iiifUrl });
  },
  setXmlJson({ dispatch, state }, { xmlJson }) {
    dispatch("update", { xmlJson: xmlJson });
  },
  setXml({ dispatch, state }, { xml }) {
    if (xml) {
      let json = parseXML(xml);

      dispatch("update", { xmlModel: json });

      let pageJson = parsePageContent(xml);

      dispatch("update", { xmlJson: pageJson });
    }
  },
  setXmlModel({ dispatch, state }, { xmlModel }) {
    dispatch("update", { xmlModel: xmlModel });
  },
  async fetch({ state, dispatch }, id) {
    // if (id) dispatch('update', { id })
    dispatch("update", { isLoading: true, isReady: false });
    await dispatch("fetchPageContent", id);
    dispatch("update", { isLoading: false, isReady: true });
  },
  async fetchPageContent({ state, dispatch }, id) {
    if (id) dispatch("update", { id });
    const data = await fetchPageContentXML(id);
    if (data === null) dispatch("update", { data: null, isError: true });
    else {
      dispatch("update", {
        data: Object.freeze(data),
        isError: false,
      });
    }
  },
  findElementById({ state }, id) {
    const node = state.xmlJson;
    const stack = [node];
    while (stack.length) {
      const node = stack.pop();
      if (node.elements) node.elements.forEach((node) => stack.push(node));
      if (node.attributes && node.attributes.id === id) return node;
    }
    return null;
  },
};

export default {
  namespaced: true,
  state,
  mutations,
  actions,
};
